temp = list(map(int,input().split()))
n,m,k = temp[0], temp[1], temp[2]

trains = [[] for i in range(k)]
friends = [[] for i in range(n + 1)]

def findTrain(train):
    for i in range(1,len(trains)):
        if train in trains[i]:
            return i
    return -1

def addTrain(a,b):
    ident = findTrain(a)
    if ident == -1:
        trains.append([a,b])
    else:
        trains[ident].append(b)

def addFriend(a,b):
    if a > b:
        a,b = b,a 
    friends[a].append(b)
    
def count(a):
    ident = findTrain(a)
    counter = 0
    for friend in friends[int(a)]:
        if friend in trains[int(ident)]:
            counter += 1
    print(counter)
    
for i in range(m):
    inp = list(map(int,input().split()))
    addFriend(inp[0],inp[1])
    
for i in range(m):
    inp = list(map(int,input().split()))
    addTrain(inp[0],inp[1])
        
for i in range(int(input())):
    query = input().split()
    if query[0] == 'T':
        addTrain(int(query[1]),int(query[2]))
    if query[0] == 'F':
        addFriend(int(query[1]),int(query[2]))
    if query[0] == '?':
        count(int(query[1]))
    
