//package olymp;

import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

/*
6
3 4 1
5 1 6
5 4 2
2 4 3
2 5 6
6 1 3
* */

public class I {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();

        LinkedList<LinkedList<Integer>> dic = new LinkedList<>();
        for (int i = 0; i < n; i++) dic.add(new LinkedList<>());

        for (int i = 0; i < n; i++) {
            int a = sc.nextInt();
            int b = sc.nextInt();
            int c = sc.nextInt();

            dic.get(a - 1).addAll(List.of(b, c));
            dic.get(b - 1).addAll(List.of(a, c));
            dic.get(c - 1).addAll(List.of(a, b));
        }

        for (LinkedList<Integer> l : dic) {

            l.remove(new Integer(1));
            l.remove(new Integer(2));
            l.remove(new Integer(3));
            l.remove(new Integer(4));
            l.remove(new Integer(5));
            l.remove(new Integer(6));
        }

        boolean[] was = new boolean[n];
        String r = "";
        int cur = 0;
        r += (cur + 1) + " ";
        cur = Math.min(dic.get(cur).getFirst(), dic.get(cur).getLast()) - 1;
        was[0] = true;
        while (cur != -1) {
            r += (cur + 1) + " ";

            was[cur] = true;

            cur = get(cur, dic, was);
        }

        System.out.println(r.substring(0, r.length() - 1));
    }

    private static int get(int a, LinkedList<LinkedList<Integer>> list, boolean[] was) {
        int f = list.get(a).get(0) - 1;
        int s = list.get(a).get(1) - 1;

        if (!was[f])
            return f;
        if (!was[s])
            return s;
        return -1;
    }
}
