#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <random>
#include <unordered_set>
#include <conio.h>
#define UNDEF -1;

using namespace std;


typedef long long int ll;

struct edge {
	int u;
	int v;
	int cost;
	edge(int a, int b, int c) {
		u = a;
		v = b;
		cost = c;
	}
};

struct event {
	int x;
	int type;
	int num;
	event(int x, int type, int num) : x(x), type(type), num(num) {}
};

struct triple {
	int first;
	int second;
	int third;
	triple(int a, int b, int c) {
		first = a;
		second = b;
		third = c;
	}
};

int main() {
	int n;
	cin >> n;
	vector<triple> v;
	for (int i = 0; i < n; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		v.push_back(triple(a, b, c));
	}

	vector<vector<int>> set(n + 1, vector<int>(n + 1, 0));

	for (int i = 0; i < n; i++) {
		set[v[i].first][v[i].second]++;
		set[v[i].first][v[i].third]++;
		set[v[i].second][v[i].first]++;
		set[v[i].second][v[i].third]++;
		set[v[i].third][v[i].second]++;
		set[v[i].third][v[i].first]++;
	}
	vector<pair<int, int>> b;
	b.push_back(make_pair(-1, -1));
	for (int i = 1; i <= n; i++) {
		int max1 = 0, max2 = 0, indM1 = 0, indM2 = 0;
		for (int j = 0; j < set[i].size(); j++) {
			if (set[i][j] > max1) {
				max2 = max1;
				indM2 = indM1;
				max1 = set[i][j];
				indM1 = j;
			}
			else if (set[i][j] > max2) {
				max2 = set[i][j];
				indM2 = j;
			}
		}
		b.push_back(make_pair(indM1, indM2));
	}

	int last = b[1].first;
	bool ok = 0;
	int count = 0;
	for (int i = b[1].first;;) {
		if (i == b[1].first) {
			if (ok == 1)
				break;
			else {
				ok = 1;
				if (b[i].first != last && b[1].first) {
					last = i;
					i = b[i].first;
					count++;
					if (count == n)
						cout << i;
					else
					cout << i << " ";
				}
				else if (i != b[1].first) {
					last = i;
					i = b[i].second;
					count++;
					if (count == n)
						cout << i;
					else
						cout << i << " ";
				}
			}
		}
		else {
			if (b[i].first != last && b[1].first) {
				last = i;
				i = b[i].first;
				count++;
				if (count == n)
					cout << i;
				else
					cout << i << " ";
			}
			else if (i != b[1].first) {
				last = i;
				i = b[i].second;
				count++;
				if (count == n)
					cout << i;
				else
					cout << i << " ";
			}
		}


	}

	return 0;
}