#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pll pair<ll, ll>
#define pb push_back
#define all(x) x.begin(), x.end()
#define mp make_pair


using namespace std;


template<class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (auto &cnt : arr) {
        in >> cnt;
    }
    return in;
}


void solve() {
    ll x, y, z;
    cin >> x >> y >> z;
    ll a, b, c;
    cin >> a >> b >> c;
    b += x;
    c += x + y;
    ll t1, t2, t3, d;
    cin >> t1 >> t2 >> t3 >> d;
    ll k, i, l, j;
    cin >> k >> i >> l >> j;
    if (k == 2) {
        i += x;
    } else if (k == 3) {
        i += x + y;
    }
    if (l == 2) {
        j += x;
    } else if (l == 3) {
        j += x + y;
    }

    map<ll, vector<pll>> g;

    function<void(ll, ll, ll)> add = [&](ll v, ll u, ll len) {
        g[v].pb({u, len});
        g[u].pb({v, len});
    };

    add(a, b + 1, d);
    add(b, c + 1, d);
    add(c, a + 1, d);

    add(a, a + 1, t1);
    add(b, b + 1, t2);
    add(c, c + 1, t3);

    if (k == 1) {
        add(a, i, abs(a - i) * t1);
        add(a + 1, i, abs(a + 1 - i) * t1);
        if (i == a) {
            add(i, b + 1, d);
        }
        if (i == a + 1) {
            add(i, c, d);
        }
    } else if (k == 2) {
        add(b, i, abs(b - i) * t2);
        add(b + 1, i, abs(b + 1 - i) * t2);
        if (i == b) {
            add(i, c + 1, d);
        }
        if (i == b + 1) {
            add(i, a, d);
        }
    } else {
        add(c, i, abs(c - i) * t3);
        add(c + 1, i, abs(c + 1 - i) * t3);
        if (i == c) {
            add(i, a + 1, d);
        }
        if (i == c + 1) {
            add(i, b, d);
        }
    }

    if (l == 1) {
        add(a, j, abs(a - j) * t1);
        add(a + 1, j, abs(a + 1 - j) * t1);
        if (j == a) {
            add(j, b + 1, d);
        }
        if (j == a + 1) {
            add(j, c, d);
        }
    } else if (l == 2) {
        add(b, j, abs(b - j) * t2);
        add(b + 1, j, abs(b + 1 - j) * t2);
        if (j == b) {
            add(j, c + 1, d);
        }
        if (j == b + 1) {
            add(j, a, d);
        }
    } else {
        add(c, j, abs(c - j) * t3);
        add(c + 1, j, abs(c + 1 - j) * t3);
        if (j == c) {
            add(j, a + 1, d);
        }
        if (j == c + 1) {
            add(j, b, d);
        }
    }

    map<ll, ll> dist1;
    dist1[i] = 0;
    set<pll> kucha;
    kucha.insert({0, i});
    while (!kucha.empty()) {
        auto cnt = *kucha.begin();
        kucha.erase(kucha.begin());
        if (dist1[cnt.second] < cnt.first) {
            continue;
        }
        for (auto e : g[cnt.second]) {
            if (!dist1.count(e.first) or dist1[e.first] > dist1[cnt.second] + e.second) {
                dist1[e.first] = dist1[cnt.second] + e.second;
                kucha.insert({dist1[e.first], e.first});
            }
        }
    }

    ll res = 8e18;
    if (i == a or i == a + 1 or i == b or i == b + 1 or i == c or i == c + 1) {
        ll v;
        if (i == a) {
            v = b + 1;
        }
        if (i == a + 1) {
            v = c;
        }
        if (i == b) {
            v = c + 1;
        }
        if (i == b + 1) {
            v = a;
        }
        if (i == c) {
            v = a + 1;
        }
        if (i == c + 1) {
            v = b;
        }
        map<ll, ll> dist2;
        dist2[i] = 0;
        set<pll> kucha1;
        kucha.insert({0, v});
        while (!kucha1.empty()) {
            auto cnt = *kucha1.begin();
            kucha1.erase(kucha1.begin());
            if (dist2[cnt.second] < cnt.first) {
                continue;
            }
            for (auto e : g[cnt.second]) {
                if (!dist2.count(e.first) or dist2[e.first] > dist2[cnt.second] + e.second) {
                    dist2[e.first] = dist2[cnt.second] + e.second;
                    kucha1.insert({dist2[e.first], e.first});
                }
            }
        }
        res = dist2[j];
    }



    cout << min(dist1[j], res);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    solve();
    return 0;
}