#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pll pair<ll, ll>
#define pb push_back
#define all(x) x.begin(), x.end()
#define mp make_pair


using namespace std;


template<class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (auto &cnt : arr) {
        in >> cnt;
    }
    return in;
}


void solve() {
    ll x, y, z;
    cin >> x >> y >> z;
    ll a, b, c;
    cin >> a >> b >> c;
    b += x;
    c += x + y;
    ll t1, t2, t3, d;
    cin >> t1 >> t2 >> t3 >> d;
    ll k, i, l, j;
    cin >> k >> i >> l >> j;

    if (k == 2) {
        i += x;
    } else if (k == 3) {
        i += x + y;
    }
    if (l == 2) {
        j += x;
    } else if (l == 3) {
        j += x + y;
    }

    if (k == l) {
        if (k == 1) {
            cout << abs(i - j) * t1;
        } else if (k == 2) {
            cout << abs(i - j) * t2;
        } else {
            cout << abs(i - j) * t3;
        }
        return;
    }

//    if (i == a and j == b + 1) {
//        cout << 0;
//        return;
//    }
//    if (i == b + 1 and j == a) {
//        cout << 0;
//        return;
//    }
//
//    if (i == b and j == c + 1) {
//        cout << 0;
//        return;
//    }
//    if (i == c + 1 and j == b) {
//        cout << 0;
//        return;
//    }
//
//    if (i == c and j == a + 1) {
//        cout << 0;
//        return;
//    }
//    if (i == a + 1 and j == c) {
//        cout << 0;
//        return;
//    }

    map<ll, vector<pll>> g;

    function<void(ll, ll, ll)> add = [&](ll v, ll u, ll len) {
        g[v].pb({u, len});
        g[u].pb({v, len});
    };

    add(a, b + 1, d);
    add(b, c + 1, d);
    add(c, a + 1, d);

    if (k == 1) {
        add(a, i, abs(a - i) * t1);
        add(a + 1, i, abs(a + 1 - i) * t1);
        if (i == a) {
            add(i, b + 1, 0);
        }
        if (i == a + 1) {
            add(i, c, 0);
        }
    } else if (k == 2) {
        add(b, i, abs(b - i) * t2);
        add(b + 1, i, abs(b + 1 - i) * t2);
        if (i == b) {
            add(i, c + 1, 0);
        }
        if (i == b + 1) {
            add(i, a, 0);
        }
    } else {
        add(c, i, abs(c - i) * t3);
        add(c + 1, i, abs(c + 1 - i) * t3);
        if (i == c) {
            add(i, a + 1, 0);
        }
        if (i == c + 1) {
            add(i, b, 0);
        }
    }

    if (l == 1) {
        add(a, j, abs(a - j) * t1);
        add(a + 1, j, abs(a + 1 - j) * t1);
        if (j == a) {
            add(j, b + 1, 0);
        }
        if (j == a + 1) {
            add(j, c, 0);
        }
    } else if (l == 2) {
        add(b, j, abs(b - j) * t2);
        add(b + 1, j, abs(b + 1 - j) * t2);
        if (j == b) {
            add(j, c + 1, 0);
        }
        if (j == b + 1) {
            add(j, a, 0);
        }
    } else {
        add(c, j, abs(c - j) * t3);
        add(c + 1, j, abs(c + 1 - j) * t3);
        if (j == c) {
            add(j, a + 1, 0);
        }
        if (j == c + 1) {
            add(j, b, 0);
        }
    }

    map<ll, ll> dist;
    dist[i] = 0;
    set<pll> kucha;
    kucha.insert({0, i});
    while (!kucha.empty()) {
        auto cnt = *kucha.begin();
        kucha.erase(kucha.begin());
        if (dist[cnt.second] < cnt.first) {
            continue;
        }
        for (auto e : g[cnt.second]) {
            if (!dist.count(e.first) or dist[e.first] > dist[cnt.second] + e.second) {
                dist[e.first] = dist[cnt.second] + e.second;
                kucha.insert({dist[e.first], e.first});
            }
        }
    }
    cout << dist[j];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    solve();
    return 0;
}