#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pll pair<ll, ll>
#define pb push_back
#define all(x) x.begin(), x.end()
#define mp make_pair


using namespace std;


template<class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (auto &cnt : arr) {
        in >> cnt;
    }
    return in;
}


void solve() {
    ll n;
    cin >> n;
    string s;
    cin >> s;
    ll m;
    cin >> m;
    vector<string> ch(m);
    cin >> ch;

    function<bool(ll, ll)> same = [&](ll i, ll j) {
        int c_i = 0, c_j = 0, same_c = 0;
        int w_i = 0, w_j = 0, w_c = 0;
        for (int k = 0; k < n; k++) {
            if (ch[i][k] == s[k]) {
                c_i++;
            } else {
                w_i++;
            }
            if (ch[j][k] == s[k]) {
                c_j++;
            } else {
                w_j++;
            }
            if (ch[j][k] == s[k] and ch[j][k] == ch[i][k]) {
                same_c++;
            } else if (ch[j][k] != s[k] and ch[j][k] == ch[i][k]) {
                w_c++;
            }
        }
        return c_i / 2 < same_c and w_j / 2 < w_c and w_i / 2 < w_c and c_j / 2 < same_c;
    };

    vector<pll> ans;
    for (int i = 0; i < m; i++) {
        for (int j = i + 1; j < m; j++) {
            if (same(i, j)) {
                ans.pb({i + 1, j + 1});
            }
        }
    }
    cout << ans.size() << "\n";
    for (auto p : ans) {
        cout << p.first << " " << p.second << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    solve();
    return 0;
}