#include <iostream>
#include <algorithm>
#include <vector>

typedef long long ll;
using namespace std;

#define int long long

int x, y, z;
int t[4];
int h[4][4];

int f(int a, int b, int k) {
	if (a > b) swap(a, b);
	return (b - a) * t[k];
}

int ans(int k, int i, int l, int j, int d) {
	if (l != k) {
		//Case 1 trans:
		int ans = f(i, h[k][l], k) + d + f(h[l][k], j, l);
		if (h[l][k] == j) ans -= d;
		//Case 2 trans:
		int tmp = -1;
		if (k != 1 && l != 1) tmp = 1;
		else if (k != 2 && l != 2) tmp = 2;
		else tmp = 3;
		int ans2 = f(i, h[k][tmp], k) + d + f(h[tmp][k], h[tmp][l], tmp) + d + f(h[l][tmp], j, l);
		if (h[l][tmp] == j) ans2 -= d;
		return min(ans, ans2);
	}
	else {
		//Case 0 trans:
		int ans = f(i, j, k);
		//Case 2 trans:
		int l = -1;
		if (k != 1) l = 1;
		else if (k != 2) l = 2;
		int tmp = -1;
		if (k != 1 && l != 1) tmp = 1;
		else if (k != 2 && l != 2) tmp = 2;
		else tmp = 3;
		int ans2 = f(i, h[k][tmp], k) + d + f(h[tmp][k], h[tmp][l], tmp) + d + f(h[l][tmp], h[l][k], l) + d + f(h[k][l], j, k);
		if (h[k][l] == j) ans2 -= d;
		swap(tmp, l);
		int ans3 = f(i, h[k][tmp], k) + d + f(h[tmp][k], h[tmp][l], tmp) + d + f(h[l][tmp], h[l][k], l) + d + f(h[k][l], j, k);
		if (h[k][l] == j) ans3 -= d;
		return min(min(ans, ans2), ans3);
	}
}

signed main() {
	cin >> x >> y >> z;
	int a, b, c; cin >> a >> b >> c;
	h[1][2] = a;
	h[2][1] = b + 1;
	h[1][3] = a + 1;
	h[3][1] = c;
	h[2][3] = b;
	h[3][2] = c + 1;
	cin >> t[1] >> t[2] >> t[3];
	int d; cin >> d;
	int k, i, l, j; cin >> k >> i >> l >> j;
	int ans1 = ans(k, i, l, j, d);
	int tmp1 = -1, tmp2 = -1;
	if (k == l) {
		if (k != 1) tmp1 = 1;
		else tmp1 = 2;
		if (tmp1 != 1 && k != 1) tmp2 = 1;
		else if (tmp1 != 2 && k != 2) tmp2 = 2;
		else tmp2 = 3;
		if (h[k][tmp1] == i) ans1 = min(ans1, ans(tmp1, h[tmp1][k], i, l, d));
		if (h[k][tmp2] == i) ans1 = min(ans1, ans(tmp2, h[tmp2][k], i, l, d));
	}
	else {
		int tmp = -1;
		if (k != 1 && l != 1) tmp = 1;
		else if (k != 2 && l != 2) tmp = 2;
		else tmp = 3;
		if (h[k][l] == i) ans1 = min(ans1, ans(l, h[l][k], i, l, d));
		if (h[k][tmp] == i) ans1 = min(ans1, ans(tmp, h[tmp][k], i, l, d));
	}
	cout << ans1 << endl;
	return 0;
}