import java.util.*;
import java.io.*;
public class Main {
    public static long dist(long x, long y, long k) {
        if (k == 1) {
            return Math.abs(x - y) * t1;
        } else if (k == 2) {
            return Math.abs(x - y) * t2;
        } else {
            return Math.abs(x - y) * t3;
        }
    }
    public static long calc(long k, long i, long l, long j) {
        if (k > l) {
            return calc(l, j, k, i);
        }
        if (k == l && i > j) {
            return calc(k, j, l, i);
        }
        long min = Long.MAX_VALUE;
        if (k == 1 && l == 1) {
            min = Math.abs(i - j) * t1;
            min = Math.min(min, dist(i, a, 1) + dist(a + 1, j, 1) + 2 * d + t2 + t3);
        } else if (k == 1 && l == 2) {
            long x = dist(i, a + 1, 1) + dist(b, j, 2) + t3 + 2 * d;
            if (j == b) x -= d;
            long y = dist(i, a, 1) + dist(b + 1, j, 2) + d;
            if (j == b + 1 || i == a) y -= d;
            min = Math.min(x, y);
        } else if (k == 1 && l == 3) {
            long x = dist(i, a, 1) + dist(c + 1, j, 3) + t2 + 2 * d;
            if (j == c) x -= d;
            long y = dist(i, a + 1, 1) + dist(c, j, 3) + d;
            if (j == c + 1 || i == a) y -= d;
            min = Math.min(x, y);
        } else if (k == 2 && l == 2) {
            min = Math.abs(i - j) * t2;
            min = Math.min(min, dist(i, b, 2) + dist(b + 1, j, 2) + 2 * d + t1 + t3);
        } else if (k == 2 && l == 3) {
            long x = dist(i, b + 1, 2) + dist(c, j, 3) + t1 + 2 * d;
            if (j == c) x -= d;
            long y = dist(i, b, 2) + dist(c + 1, j, 3) + d;
            if (j == c + 1 || i == b) y -= d;
            min = Math.min(x, y);
        } else {
            min = Math.abs(i - j) * t3;
            min = Math.min(min, dist(i, c, 3) + dist(c + 1, j, 3) + 2 * d + t1 + t2);
        }
        return min;
    }
    public static long x, y, z, a, b, c, t1, t2, t3, d, k, i, l, j;
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        x = in.nextLong();
        y = in.nextLong();
        z = in.nextLong();
        a = in.nextLong();
        b = in.nextLong();
        c = in.nextLong();
        t1 = in.nextLong();
        t2 = in.nextLong();
        t3 = in.nextLong();
        d = in.nextLong();
        k = in.nextLong();
        i = in.nextLong();
        l = in.nextLong();
        j = in.nextLong();
        System.out.println(calc(k, i, l, j));
    }
}
