#include <bits/stdc++.h>

using namespace std;

int n;
vector<int> ans;

void dfs(vector<unordered_set<int>> &g, vector<bool> &us, int v){
    us[v] = true;
    ans.push_back(v + 1);
    for(auto u : g[v]){
        if(us[u] && u == 0 && ans.size() == n){
            while(ans.size()){
                int q = ans.back();
                ans.pop_back();
                cout << q;
                if(ans.size() != 0){
                    cout << " ";
                }
            }
            exit(0);
        }
        else if(!us[u]){
            dfs(g, us, u);
        }
    }
    ans.pop_back();
}

int main() {
    cin >> n;
    vector<unordered_set<int>> graph(n);
    for (int i = 0; i < n; ++i){
        int a1, a2, a3;
        cin >> a1 >> a2 >> a3;
        a1--;
        a2--;
        a3--;
        graph[a1].insert(a2);
        graph[a1].insert(a3);
        graph[a2].insert(a1);
        graph[a2].insert(a3);
        graph[a3].insert(a1);
        graph[a3].insert(a2);
    }
    vector<bool> used(n, false);
    dfs(graph, used, 0);
    return 0;
}