#/*include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void print_degr(vector<int> degr, int sum = 0)
{
	for (int i = 0; i < degr.size(); i++)
	{
		if (degr[i] != -1)
		{
			cout << sum << " " << 0 << endl;
			sum += degr[i];
		}
	};
}

int mainD2()
{
	ios::sync_with_stdio();
	cout.tie();
	cin.tie();

	int n;
	cin >> n;
	vector<int> degr;
	
	degr.resize(n, 0);
	for (int i = 0; i < n; i++)
		cin >> degr[i];
	sort(degr.begin(), degr.end());
	if (n == 1 && degr[0] == 360)
	{
		cout << 0;
		return 0;
	}
	else if (n == 1 && degr[0] == 180)
	{
		cout << 1 << endl;
		cout << 0 << 1 << endl;
		return 0;
	}
	else if (n == 1)
	{
		cout << 2 << endl;
		cout << 0 << " " << 0 << endl << degr[0] << " " << 0 << endl;
		return 0;
	}

	
	int biggest = degr[degr.size() - 1];
	if (biggest >= 180)
	{
		cout << degr.size() << endl;
		print_degr(degr);
		return 0;
	}
	
	vector<int> pairs;
	for (int i = 0; i < n - 1; i++)
		if (degr[i] == degr[i + 1])
		{
			pairs.push_back(degr[i]); 
			degr[i] = -1;
			degr[i + 1] = -1;;
		}

	vector<int> ans;
	ans.push_back(0);
	int curr_degr = 0;
	int q = 0;
	if (!pairs.empty())
		do 
		{
			curr_degr += pairs[q];
			if(curr_degr != 180)
				ans.push_back(curr_degr);
			q++;
		} while (180 - curr_degr >= biggest && q < pairs.size());
	for (; q < pairs.size(); q++)
	{
		degr.push_back(pairs[q]);
		degr.push_back(pairs[q]);
	};
	sort(degr.begin(), degr.end());
	
	while (!degr.empty() && degr[0] == -1)
		degr.erase(degr.begin());

	cout << ans.size() + degr.size() << endl;
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i] << " " << 1 << endl;

	int curr_degr1 = curr_degr, curr_degr2 = 180 + curr_degr;
	for (int i = 0; i < degr.size(); i++)
		if (i % 2 == 0)
		{
			curr_degr1 += degr[i];
			cout << curr_degr1 << " " << 0 << endl;
		}
		else
		{
			curr_degr2 += degr[i];
			cout << curr_degr2 << " " << 0 << endl;
		}


}*/


#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <list>
using namespace std;



int main()
{
	int n, m;
	cin >> n;

	string correct;
	cin >> correct;

	cin >> m;
	vector<string> answers;
	list <pair<int, int>> com;
	answers.resize(m);
	for (int i = 0; i < m; i++)
		cin >> answers[i];

	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++)
		{
			int corr1 = 0, corr2 = 0, corrC = 0;
			int incorr1 = 0, incorr2 = 0, incorrC = 0;
			for (int l = 0; l < correct.size(); l++)
			{
				if (answers[i][l] == answers[j][l] && answers[j][l] == correct[l])
				{
					corrC++;
					corr1++;
					corr2++;
				}
				else if (answers[i][l] == correct[l])
					corr1++;
				else if (answers[j][l] == correct[l])
					corr2++;
				else if (answers[i][l] == answers[j][l] && answers[j][l] != correct[l])
				{
					incorrC++;
					incorr1++;
					incorr2++;
				}
				else if (answers[i][l] != correct[l])
					incorr1++;
				else if (answers[j][l] != correct[l])
					incorr2++;
			}
			if (corrC > corr1 / 2 && corrC > corr2 / 2 && incorrC > incorr1 / 2 && incorrC > incorr2 / 2)
				com.push_back({ i, j });
		}
	cout << com.size() << endl;
		for (auto i = com.begin(); i != com.end(); i++)
		{
			cout << i->first + 1 << "  " << i->second + 1 << endl;
		};
	return 0;

}