#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>

int main( void )
{
  long long n, m, s;
  std::vector<long long *> Pays;

  std::cin >> n >> m >> s;

  if (n < 1 || n > 1000 || m < 1 || m > 1000)
  {
	printf("NO");
	return 0;
  }
  if (s < 1 || s > 1e6)
  {
	printf("NO");
	return 0;
  }

  for (int i(0); i < n; i++)
  {
	long long *p = new long long[3];

	std::cin >> p[0] >> p[1] >> p[2];

	if (p[0] < -1e6 || p[0] > 1e6)
	{
	  printf("NO");
	  return 0;
	}
	if (p[1] < 1 || p[2] < p[1] || p[2] > m || p[2] < 1 || p[1] > m)
	{
	  printf("YES");
	  return 0;
	}
	Pays.push_back(p);
  }

  for (int i(0); i < m; i++)
  {
	long long sum(0), day(0), max = -INFINITY;

	for (int j(0); j < n; j++)
	  if (Pays[j][1] == i + 1)
		if (max < Pays[j][2])
		  max = Pays[j][2];

	for (int j(0); j < n; j++)
	  if (Pays[j][2] == max)
		if (Pays[j][0] < 0)
		  sum += Pays[j][0];

	if (s + sum < 0)
	{
	  std::cout << "YES";
	  return 0;
	}
  }

  std::cout << "NO";
  return 0;
}