//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,popcnt,tune=native")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<ll> > pos;
vector<vector<ll> > A;

vector<set<ll> > g;

ll n;

ll kolob(ll i, ll j)
{
    ll k = 0;
    for (int x = 0; x < 3; x ++)
    {
        for (int y = 0; y < 3; y++)
        {
            if (A[i][x] == A[j][y])
                k++;
        }
    }
    return k;
}

ll neob(ll i, ll j)
{
    for (int x = 0; x < 3; x++)
    {
        ll k = 0;
        for (int y = 0; y < 3; y++)
        {
            if (A[i][x] == A[j][y])
            {
                k++;
                break;
            }
        }
        if (k == 0)
            return A[i][x];
    }
    assert(false);
}

void dfs(ll v, ll pr = -1)
{
    //cout << "v = " << v << endl;
    if (v == 0 && pr != -1)
        exit(0);
    for (ll to: g[v])
    {
        if (to == pr)
            continue;
        cout << neob(v, to) + 1 << " ";
        dfs(to, v);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    if (n == 3)
    {
        cout << "1 2 3";
        return 0;
    }
    if (n == 4)
    {
        cout << "1 2 3 4";
        return 0;
    }
    A.resize(n, vector<ll> (3));
    pos.resize(n);
    g.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> A[i][0] >> A[i][1] >> A[i][2];
        A[i][0]--;
        A[i][1]--;
        A[i][2]--;
        pos[A[i][0]].push_back(i);
        pos[A[i][1]].push_back(i);
        pos[A[i][2]].push_back(i);
    }

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < 3; j++)
        {
            ll x = A[i][j];
            for (int id = 0; id < pos[x].size(); id++)
            {
                ll to = pos[x][id];
                if (to == i)
                    continue;
                if (kolob(i, to) == 2)
                {
                    g[i].insert(to);
                    g[to].insert(i);
                }
            }
        }
    }
    dfs(0);
    assert(false);
}
