#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long LL;

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

	LL cpaid, days, start;
	LL res, to, from;
	
	cin >> cpaid >> days >> start;

	LL operin[2000] = {0};
	LL operus[2000] = { 0 };

	for (LL i = 0; i < cpaid; i++)
	{
		cin >> res >> from >> to;
		if (res < 0)
			operin[from] += res;
		else
			operus[to] += res;
	}

	for (LL i = 1; i < days + 1; i++)
	{
		start += operin[i];
		if (start < 0)
		{
			cout << "YES";
			return 0;
		}
		start += operus[i];
	}
	cout << "NO";
	return 0;
}
