//package olymp;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

public class H {

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);

        int len = s.nextInt();
        String trueAnsw = s.next();

        int q = s.nextInt();
        int[][] user = new int[q][len];
        String[] us = new String[q];
        for (int i = 0; i < q; i++) {
            us[i] = s.next();
            user[i] = toByte(us[i], trueAnsw, len);
        }

        ArrayList<pair> r = new ArrayList<>();
        for (int i = 0; i < q - 1; i++) {
            for (int j = i + 1; j < q; j++) {
                if (check(user[i], user[j], us[i], us[j])) {
                    r.add(new pair(i + 1, j + 1));
                }
            }
        }

        System.out.println(r.size());
        for (pair pair : r) System.out.println(pair);
    }

    static class pair {
        int i, j;

        public pair(int i, int j) {
            this.i = i;
            this.j = j;
        }

        @Override
        public String toString() {
            return i + " " + j;
        }
    }

    private static int[] toByte(String s, String answ, int len) {
        int[] r = new int[len];

        String[] masS = s.split("");
        String[] masAnsw = answ.split("");
        for (int i = 0; i < len; i++) {
            if (masS[i].equals(masAnsw[i]))
                r[i] = 1;
            else
                r[i] = 0;
        }

        return r;
    }

    private static boolean check(int[] f, int[] s, String f_, String s_) {
        int tOk = 0;
        int fOk = 0;

        for (int i = 0; i < f.length; i++) {
            if (f_.charAt(i) == s_.charAt(i)) {
                if (f[i] == 1)
                    tOk++;
                else
                    fOk++;
            }
        }

        return tOk > is(f).i / 2 && fOk > is(f).j / 2 &&
                tOk > is(s).i / 2 && fOk > is(s).j / 2;
    }

    private static pair is(int[] m) {
        int _0 = 0;
        int _1 = 0;

        for (int value : m) {
            if (value == 1)
                _1++;
            else
                _0++;
        }

        return new pair(_1, _0);
    }
}
