#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pll pair<ll, ll>
#define pb push_back
#define all(x) x.begin(), x.end()
#define mp make_pair
#define inf (4ll * 1e18)

using namespace std;


template<class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (auto &cnt : arr) {
        in >> cnt;
    }
    return in;
}

vector<vector<pll> > nodes;
vector<vector<ll> > points;
ll d, k, ii, l, jj;
vector<ll> x, a, t;

vector<ll> addVertex(ll line, ll pos)
{
    if((line == 0 && pos == a[0]) || (line == 1 && pos == a[1] + 1))
        return {0, 1};
    if((line == 0 && pos == a[0] + 1) || (line == 2 && pos == a[2]))
        return {4, 5};
    if((line == 1 && pos == a[1]) || (line == 2 && pos == a[2] + 1))
        return {2, 3};

    nodes.pb({});
    ll cur = nodes.size() - 1;
    vector<ll> dist = {abs(a[line] - pos) * t[line],
                       abs(a[line] + 1 - pos) * t[line]};

    for(int i = 0; i < 2; i++)
    {
        ll to = points[line][i];
        nodes[cur].pb({to, dist[i]});
        nodes[to].pb({cur, dist[i]});
    }

    return {cur};
}

#define f first
#define s second

ll countDist(ll start, ll finish)
{
    vector<ll> dist(nodes.size(), inf);
    dist[start] = 0;

    set<pll> st;
    for(int i = 0; i < nodes.size(); i++)
        st.insert({dist[i], i});

    while(st.size() > 0)
    {
        pll cur = *(st.begin());
        st.erase(st.begin());

        ll v = cur.s;
        for(int i = 0; i < nodes[v].size(); i++)
        {
            ll to = nodes[v][i].f;
            if(dist[to] > dist[v] + nodes[v][i].s)
            {
                st.erase({dist[to], to});
                dist[to] = dist[v] + nodes[v][i].s;
                st.insert({dist[to], to});
            }
        }
    }
    return dist[finish];
}

void solve() {
    points.pb({0, 4});
    points.pb({2, 1});
    points.pb({5, 3});

    x.resize(3); a.resize(3); t.resize(3); nodes.resize(6);
    cin >> x[0] >> x[1] >> x[2];
    cin >> a[0] >> a[1] >> a[2];
    cin >> t[0] >> t[1] >> t[2] >> d;

    cin >> k >> ii >> l >> jj;
    k--;
    l--;

    nodes[0].pb({1, d});
    nodes[0].pb({4, t[0]});
    nodes[1].pb({2, t[1]});
    nodes[1].pb({0, d});
    nodes[2].pb({3, d});
    nodes[2].pb({1, t[1]});
    nodes[3].pb({2, d});
    nodes[3].pb({5, t[2]});
    nodes[4].pb({5, d});
    nodes[4].pb({0, t[0]});
    nodes[5].pb({4, d});
    nodes[5].pb({3, t[2]});

    vector<ll> start = addVertex(k, ii);
    vector<ll> finish = addVertex(l, jj);

    cerr << "nodes" << endl;
    for(int i = 0; i < nodes.size(); i++)
    {
        cerr << "i = " << i << endl;
        for(int j = 0 ; j < nodes[i].size(); j++)
            cerr << nodes[i][j].f << " " << nodes[i][j].s << endl;
        cerr << endl;
    }

    for(int i = 0; i < start.size(); i++)
        cerr << start[i] << " ";
    cerr << endl;
    for(int i = 0; i < finish.size(); i++)
        cerr << finish[i] << " ";
    cerr << endl;
    ll answ = inf;
    for(int i = 0; i < start.size(); i++)
    {
        for (int j = 0; j < finish.size(); j++)
        {
            answ = min(answ, countDist(start[i], finish[j]));
        }
    }

    if(l == k)
    {
        answ = min(answ, abs(ii - jj) * t[l]);
    }
    cout << answ << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    solve();
    return 0;
}