#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pll pair<ll, ll>
#define pb push_back
#define all(x) x.begin(), x.end()
#define mp make_pair


using namespace std;


template<class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (auto &cnt : arr) {
        in >> cnt;
    }
    return in;
}

vector<ll> answ;
vector<bool> used;

vector<vector<ll> > g;

void dfs(ll cur)
{
    if(used[cur])
        return;
    used[cur] = 1;

    answ.pb(cur);
    for(int i = 0; i < g[cur].size(); i++)
    {
        if(!used[g[cur][i]])
            dfs(g[cur][i]);
    }
}

void solve() {
    ll n;
    cin >> n;
    vector<vector<ll> > nodes(n);

    for(int i = 0; i < n; i++)
    {
        vector<ll> temp(3);
        for(int j = 0; j < 3; j++)
        {
            cin >> temp[j];
            temp[j]--;
        }
        for(int j = 0; j < 3; j++)
        {
            for (int k = j + 1; k < 3; k++)
            {
                nodes[temp[j]].pb(temp[k]);
                nodes[temp[k]].pb(temp[j]);
            }
        }
    }

    g.resize(n);
    for(int i = 0; i < n; i++)
    {
        map<int, bool> mp;
        for(int j = 0; j < nodes[i].size(); j++)
        {
            if(mp.count(nodes[i][j]) != 0)
                g[i].pb(nodes[i][j]);
            else
                mp[nodes[i][j]] = 1;
        }
    }

    used.resize(n);
    dfs(0);
    for(int i = 0; i < answ.size(); i++)
        cout << answ[i] + 1 << " ";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    solve();
    return 0;
}