#include <iostream>
#include <set>

using namespace std;


string correct;

bool check(string &a, string &b) {
    int cnt1 = 0;
    int cnt1Total = 0;
    for (int i = 0; i < a.size(); ++i) {
        if (a[i] == correct[i]) {
            cnt1Total++;
            if (a[i] == b[i]) {
                cnt1++;
            }
        }
    }
    int cnt2 = 0;
    int cnt2Total = 0;

    for (int i = 0; i < a.size(); ++i) {
        if (a[i] != correct[i]) {
            cnt2Total++;
            if (a[i] == b[i]) {
                cnt2++;
            }
        }
    }
    return cnt1 > cnt1Total / 2 && cnt2 > cnt2Total / 2;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    cin >> correct;
    int m;
    cin >> m;
    string a[m];
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
    }
    set<pair<int, int>> ans;
    for (int i = 0; i < m; ++i) {
        for (int j = i + 1; j < m; ++j) {
            if (i == j) {
                continue;
            }
            if (check(a[i], a[j]) && check(a[j], a[i])) {
                ans.insert({i + 1, j + 1});
            }
        }
    }
    cout << ans.size() << "\n";
    for (auto &[x, y] : ans) {
        cout << x << " " << y << "\n";
    }

    return 0;
}