#include <iostream>
#include <vector>
#include <map>


using namespace std;

typedef tuple<int, int, int, int> th;

pair<int, int> create(int a, int b) {
    return {min(a, b), max(a, b)};
}

const int MAX_N = 200005;

vector<int> g[MAX_N];
bool used[MAX_N];
th a[MAX_N];
bool isIn(th &t, int c) {
    auto &[x, y, z, ind] = t;
    return x==c || y == c || z == c;
}

void dfs(int v) {
    used[v] = true;
    auto [x, y, z, ind] = a[v];
    for (auto curAns : {x, y, z}) {
        if(isIn(a[g[v][0]], curAns)  && isIn(a[g[v][1]], curAns)) {
            cout << curAns << " ";
            break;
        }
    }
    for (int u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}
#undef LOCAL

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    if (n == 3) {
        cout << "1 2 3\n";
        return 0;
    }
    map<pair<int, int>, vector<th>> mp;
    for (int i = 0; i < n; ++i) {
        auto &[x, y, z, ind] = a[i];
        ind = i;
        cin >> x >> y >> z;
        mp[create(x, y)].push_back(a[i]);
        mp[create(x, z)].push_back(a[i]);
        mp[create(z, y)].push_back(a[i]);
    }
#ifdef LOCAL
    for (auto &[k, v] : mp) {
        cout << k.first << " " << k.second << endl;
        for (auto p:v) {
            auto &[x, y, z, ind] = p;
            cout << x << " " << y << " "  << z << ind<< endl;
        }
    }
#endif

    for (auto &[k, v] : mp) {
        if (v.size() >= 2) {
            for (int i = 0; i < v.size(); ++i) {
                for (int j = i + 1; j < v.size(); ++j) {
                    auto &[x, y, z, ind] = v[i];
                    auto &[x2, y2, z2, ind2] = v[j];
                    g[ind].push_back(ind2);
                    g[ind2].push_back(ind);
                }
            }
        }
    }
    dfs(0);
}