#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void print_degr(vector<int> degr, int sum = 0)
{
	for (int i = 0; i < degr.size(); i++)
	{
		if (degr[i] != -1)
		{
			cout << sum << " " << 0 << endl;
			sum += degr[i];
		}
	};
}

int main()
{
	ios::sync_with_stdio();
	cout.tie();
	cin.tie();

	int n;
	cin >> n;
	vector<int> degr;
	
	degr.resize(n, 0);
	for (int i = 0; i < n; i++)
		cin >> degr[i];
	sort(degr.begin(), degr.end());
	int biggest = degr[degr.size() - 1];
	if (biggest >= 180)
	{
		cout << degr.size() << endl;
		print_degr(degr);
		return 0;
	}

	vector<int> pairs;
	for (int i = 0; i < n - 1; i++)
		if (degr[i] == degr[i + 1])
		{
			pairs.push_back(degr[i]); 
			degr[i] = -1;
			degr[i + 1] = -1;;
		}

	vector<int> ans;
	ans.push_back(0);
	int curr_degr = 0;
	int q = 0;
	do 
	{
		curr_degr += pairs[q];
		if(curr_degr != 180)
			ans.push_back(curr_degr);
		q++;
	} while (180 - curr_degr >= biggest && q < pairs.size());
	for (; q < pairs.size(); q++)
	{
		degr.push_back(pairs[q]);
		degr.push_back(pairs[q]);
	};
	sort(degr.begin(), degr.end());
	
	while (!degr.empty() && degr[0] == -1)
		degr.erase(degr.begin());

	cout << ans.size() + degr.size() << endl;
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i] << " " << 1 << endl;

	int curr_degr1 = curr_degr, curr_degr2 = 180 + curr_degr;
	for (int i = 0; i < degr.size(); i++)
		if (i % 2 == 0)
		{
			curr_degr1 += degr[i];
			cout << curr_degr1 << " " << 0 << endl;
		}
		else
		{
			curr_degr2 += degr[i];
			cout << curr_degr2 << " " << 0 << endl;
		}


}