#include <bits/stdc++.h>
using namespace std;

#define int long long
const int start = 0, finish = 1, t12_1 = 2, t12_2 = 3, t13_1 = 4, t13_3 = 5, t23_2 = 6, t23_3 = 7;
string s[8] = {"start", "finish", "t12_1", "t12_2", "t13_1", "t13_3", "t23_2", "t23_3"};
const int INF = 1e9;
int dist[8][8];

inline void sdist(int x, int y, int d){
    dist[x][y] = d;
    dist[y][x] = d;
}

signed main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int x, y, z;  //   ( )
    int a, b, c;  // 
    int t1, t2, t3, transfer_time;  //     
    int line1, st1, line2, st2;  //    
    cin >> x >> y >> z >> a >> b >> c >> t1 >> t2 >> t3 >> transfer_time >> line1 >> st1 >> line2 >> st2;

    for(int i = 0; i < 8; i++){
        for(int j = 0; j < 8; j++){
            if(i != j)
                dist[i][j] = INF;
            else
                dist[i][i] = 0;
        }
    }
    sdist(t12_1, t12_2, transfer_time);
    sdist(t13_1, t13_3, transfer_time);
    sdist(t23_2, t23_3, transfer_time);

    sdist(t12_1, t13_1, 1);
    sdist(t12_2, t23_2, 1);
    sdist(t13_3, t23_3, 1);
    /// first
    if(line1 == 1){
        sdist(t12_1, start, abs(a - st1) * t1);
        sdist(t13_1, start, abs(a + 1 - st1) * t1);
    }
    if(line1 == 2){
        sdist(t23_2, start, abs(b - st1) * t2);
        sdist(t12_2, start, abs(b + 1 - st1) * t2);
    }
    if(line1 == 3){
        sdist(t13_3, start, abs(c - st1) * t3);
        sdist(t23_3, start, abs(c + 1 - st1) * t3);
    }
    /// second
    if(line2 == 1){
        sdist(t12_1, finish, abs(a - st2) * t1);
        sdist(t13_1, finish, abs(a + 1 - st2) * t1);
    }
    if(line2 == 2){
        sdist(t23_2, finish, abs(b - st2) * t2);
        sdist(t12_2, finish, abs(b + 1 - st2) * t2);
    }
    if(line2 == 3){
        sdist(t13_3, finish, abs(c - st2) * t3);
        sdist(t23_3, finish, abs(c + 1 - st2) * t3);
    }

    if(line1 == line2){
        //cout << "fuk!" << endl;;
        int coeff;
        if(line1 == 1)
            coeff = t1;
        else if(line1 == 2)
            coeff = t2;
        else
            coeff = t3;
        sdist(start, finish, abs(st2 - st1) * coeff);
    }
    /*cout << "start - t12_1: " << dist[start][t12_1] << endl;
    cout << "t12_1 - t12_2: " << dist[t12_1][t12_2] << endl;
    cout << "t12_2 - finish: " << dist[t12_2][finish] << endl;

    for(int i = 0; i < 8; i++){
        for(int j = i + 1; j < 8; j++){
            if(dist[i][j] == 1)
                cout << "one between " << s[i] << " and " << s[j] << endl;
        }
    }*/
    for(int k = 0; k < 8; k++){
        for(int i = 0; i < 8; i++){
            for(int j = 0; j < 8; j++){
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }

    cout << dist[start][finish];
    return 0;
}
