// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")
 
#include <bits/stdc++.h>
using namespace std;
 
#define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl;
#define fastIO std::ios_base::sync_with_stdio(false);std::cin.tie(0);std::cout.tie(0);
#define NAME "Problem Name"
 
typedef long long ll;
typedef long double ld;
 
std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
 
const double PI = atan2(0., -1.);
const int INF = 0x3f3f3f3f;
const int N = 9;
 
ll n, m, x;
vector <ll> a, b;
 
vector < pair<ll, ll> > havea, haveb;
ll curmask;
 
void reca(int i, ll sum) {
    if (i == (int)a.size()) {
        havea.push_back(make_pair(sum, curmask));
        return;
    }
 
    // ne berem
    curmask *= 3ll;
    reca(i + 1, sum);
    curmask /= 3ll;
 
    // berem +
    curmask = curmask * 3ll + 1ll;
    reca(i + 1, (sum + a[i] % m) % m);
    curmask = (curmask - 1ll) / 3ll;
 
    // berem -
    curmask = curmask * 3ll + 2ll;
    reca(i + 1, (sum + m - a[i] % m) % m);
    curmask = (curmask - 2ll) / 3ll;
}
 
void recb(int i, ll sum) {
    if (i == (int)b.size()) {
        haveb.push_back(make_pair(sum, curmask));
        return;
    }
 
    // ne berem
    curmask *= 3ll;
    recb(i + 1, sum);
    curmask /= 3ll;
 
    // berem +
    curmask = curmask * 3ll + 1ll;
    recb(i + 1, (sum + b[i] % m) % m);
    curmask = (curmask - 1ll) / 3ll;
 
    // berem -
    curmask = curmask * 3ll + 2ll;
    recb(i + 1, (sum + m - b[i] % m) % m);
    curmask = (curmask - 2ll) / 3ll;
}
 
bool cmp (pair <ll, ll> a, pair<ll, ll> b) {
    return a.second < b.second;
}
 
 
int main(void) {
    // #ifdef ONLINE_JUDGE
    //  freopen(NAME".in", "r", stdin);
    //  freopen(NAME".out", "w", stdout);
    // #endif
 
    cin >> n >> m;
 
    for (int i = 0; i < n; i++) {
        cin >> x;
        if (i < n / 2)
            a.push_back(x);
        else
            b.push_back(x);
    }
 
    curmask = 0ll;
    reca(0, 0ll);
 
    curmask = 0ll;
    recb(0, 0ll);
 
    sort(havea.begin(), havea.end(), cmp);
    sort(haveb.begin(), haveb.end(), cmp);
 
    /*for (int i = 0; i < (int)havea.size(); i++)
        cout << havea[i].first << " " << havea[i].second << endl;
 
    for (int i = 0; i < (int)haveb.size(); i++)
        cout << haveb[i].first << " " << haveb[i].second << endl;*/
 
    map<ll, ll> have;
    for (int i = 0; i < (int)havea.size(); i++) {
        have[havea[i].first] = havea[i].second;
    }
 
    for (int i = 0; i < (int)haveb.size(); i++) {
        ll d = (m - haveb[i].first) % m;
        if (have.count(d) != 0 && (haveb[i].second != 0ll || have[d] != 0ll)) {
            vector <ll> ansa, ansb;
            curmask = have[d];
            for (int j = 0; j < (int)a.size(); j++) {
                if (curmask % 3ll == 1ll)
                    ansa.push_back((int)a.size() - j - 1);
                if (curmask % 3ll == 2ll)
                    ansb.push_back((int)a.size() - j - 1);
                curmask /= 3ll;
            }
            reverse(ansa.begin(), ansa.end());
 
            curmask = haveb[i].second;
            for (int j = 0; j < (int)b.size(); j++) {
                if (curmask % 3ll == 1ll)
                    ansa.push_back((int)b.size() - j - 1 + n / 2);
                if (curmask % 3ll == 2ll)
                    ansb.push_back((int)b.size() - j - 1 + n / 2);
                curmask /= 3ll;
            }
            reverse(ansb.begin(), ansb.end());
 
            // cout << (int)ansa.size() + (int)ansb.size() << '\n';
            cout << ansa.size() << '\n';
            for (int j = 0; j < (int)ansa.size(); j++)
                cout << ansa[j] + 1 << " ";
            cout << '\n';
            cout << ansb.size() << '\n';
            for (int j = 0; j < (int)ansb.size(); j++)
                cout << ansb[j] + 1 << " ";
            cout << '\n';
            return 0; 
        }
    }
    cout << -1;
 
    return 0;
}
